﻿Imports System
Imports System.Data
Imports System.Reflection
Imports System.Collections.Generic
Imports Infragistics.Web.UI.GridControls
Imports Infragistics.Web.UI
Imports Infragistics.WebUI.UltraWebChart
Imports Infragistics.UltraChart.Core.Layers
Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Shared.Styles

Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        BindGrid()
    End Sub

    Private Sub BindGrid()

        Dim YearBand As New Band
        YearBand.Key = "Year_Band0"
        YearBand.DataKeyFields = "Year"
        Dim DS As New DataSet
        Dim YearData As DataTable = GetYears()
        YearData.TableName = "Year"
        DS.Tables.Add(YearData)
        WebHierarchicalDataGrid1.Bands.Add(YearBand)
        WebHierarchicalDataGrid1.EnableDataViewState = True
        WebHierarchicalDataGrid1.ViewStateMode = UI.ViewStateMode.Enabled
        WebHierarchicalDataGrid1.InitialDataBindDepth = 0
        WebHierarchicalDataGrid1.InitialExpandDepth = 0
        WebHierarchicalDataGrid1.EnableAjax = False
        WebHierarchicalDataGrid1.DataKeyFields = "Year"
        WebHierarchicalDataGrid1.DataSource = DS
    End Sub

    Public Function GetDays(ByVal Year As String, ByVal Month As String) As DataTable

        Dim DT As New DataTable
        DT.Columns.Add("Year", GetType(String))
        DT.Columns.Add("Month", GetType(String))
        DT.Columns.Add("Day", GetType(String))
        DT.PrimaryKey = New DataColumn() {DT.Columns("Year"), DT.Columns("Month"), DT.Columns("Day")}


        Dim DayArray() As String = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}

        For Each Day As String In DayArray
            DT.Rows.Add(Year, Month, Day)
        Next



        Return DT

    End Function

    Public Function GetMonths(ByVal Year As String) As DataTable

        Dim DT As New DataTable
        DT.Columns.Add("Year", GetType(String))
        DT.Columns.Add("Month", GetType(String))
        DT.PrimaryKey = New DataColumn() {DT.Columns("Year"), DT.Columns("Month")}

        Dim MonthArray() As String = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}


        For Each Month As String In MonthArray
            DT.Rows.Add(Year, Month)
        Next

        Return DT

    End Function

    Public Function GetYears() As DataTable



        Dim DT As New DataTable
        DT.Columns.Add("Year", GetType(String))
        DT.PrimaryKey = New DataColumn() {DT.Columns("Year")}

        Dim YearArray() As String = {"2012", "2011", "2010", "2009", "2008", "2007", "2006", "2005"}

        For Each year As String In YearArray
            DT.Rows.Add(year)
        Next

        Return DT

    End Function

    Private Sub WebHierarchicalDataGrid1_InitializeRow(sender As Object, e As Infragistics.Web.UI.GridControls.RowEventArgs) Handles WebHierarchicalDataGrid1.InitializeRow
        If DirectCast(e.Row, ContainerGridRecord).Level < 2 Then
            DirectCast(e.Row, ContainerGridRecord).IsEmptyParent = True
        End If
    End Sub

    Private Sub WebHierarchicalDataGrid1_PreRender(sender As Object, e As System.EventArgs) Handles WebHierarchicalDataGrid1.PreRender
        If Not IsPostBack Then
            For Each row As ContainerGridRecord In WebHierarchicalDataGrid1.GridView.Rows
                row.IsEmptyParent = True
            Next
        End If
    End Sub

    Private Sub WebHierarchicalDataGrid1_RowIslandsPopulating(sender As Object, e As Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs) Handles WebHierarchicalDataGrid1.RowIslandsPopulating
        e.Cancel = True
        Select Case e.Row.Level
            Case 0
                If e.Row.Expanded = False Then BindSecondLevel(e)
            Case 1
                If e.Row.Expanded = False Then BindThirdLevel(e)
        End Select
    End Sub

    Private Sub BindSecondLevel(ByVal e As Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs)


        Dim Year As String
        Year = e.Row.DataKey(0)
 
        Dim DS As New DataSet
        Dim MonthTable As DataTable = GetMonths(Year)
        MonthTable.TableName = "Month"
        DS.Tables.Add(MonthTable)

        Dim MonthGrid As New ContainerGrid()
        e.Row.RowIslands.Add(MonthGrid)
        MonthGrid.Level = 1
        MonthGrid.DataMember = "Month"
        MonthGrid.DataKeyFields = "Year,Month"
        MonthGrid.DataSource = DS


    End Sub

    Private Sub BindThirdLevel(ByVal e As Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs)


        Dim Year As String
        Year = e.Row.DataKey(0)
        Dim Month As String
        Month = e.Row.DataKey(1)

        Dim DS As New DataSet
        Dim DayTable As DataTable = GetDays(Year, Month)
        DayTable.TableName = "Month"
        DS.Tables.Add(DayTable)

        Dim DayGrid As New ContainerGrid()
        e.Row.RowIslands.Add(DayGrid)
        DayGrid.Level = 2
        DayGrid.DataMember = "Day"
        DayGrid.DataKeyFields = "Year,Month,Day"
        DayGrid.DataSource = DS


    End Sub
End Class